#include "StdAfx.h"
#include "skinmenu.h"

CSkinMenu::CSkinMenu(void)
{
	CMenu::CreatePopupMenu() ;  
	ZeroMemory(&m_clrSchema,sizeof(COLORINDEX) * 6) ;  

}

CSkinMenu::~CSkinMenu(void)
{
	POSITION ps = m_aoItems.GetHeadPosition() ; 
	while (ps) 
	{
		MenuData* menuData =  m_aoItems.GetAt(ps);  
		DeleteObject(menuData->bmpItem) ; 
		DeleteObject(menuData->bmpUchecked) ; 
		DeleteObject(menuData->fontText) ;
		delete menuData ; 
		m_aoItems.GetNext(ps) ; 
		
	}

}

void CSkinMenu::DrawItem( LPDRAWITEMSTRUCT lpDrawItemStruct )
{
	UINT nItemID = lpDrawItemStruct->itemID ; 
	MenuData * menuData = GetItemData(nItemID) ; 

	CRect rc = lpDrawItemStruct->rcItem ; 
	HBITMAP bmpItem = menuData->bmpItem ;  
	HBITMAP bmpUcheckedItem = menuData->bmpUchecked ; 
	CFont* pFont = menuData->fontText ; 

	CDC* pDC = CDC::FromHandle(lpDrawItemStruct->hDC) ; 
	
	COLORREF clrHiLite = menuData->clrHiLite ; 
	COLORREF clrBkg = menuData->clrBkg ; 
	COLORREF clrText = menuData->clrText ; 
	COLORREF clrItemDisable = menuData->clrItemDisable  ; 
	COLORREF clrTextDisable = menuData->clrTxtDisable ;
	COLORREF clrBorder = menuData->cltBorder ; 
	
		
	if ((lpDrawItemStruct->itemState & ODS_SELECTED)&&
      (lpDrawItemStruct->itemAction & (ODA_SELECT | ODA_DRAWENTIRE)))
	{
		
		pDC->FillSolidRect(&rc,clrHiLite);
		CBrush brush(clrBorder) ; 
		pDC->FrameRect(&rc,&brush) ; 
	
	}
	if (lpDrawItemStruct->itemAction & ODA_DRAWENTIRE)
	{
		//normal item 
		UINT nFlags =  GetMenuState(lpDrawItemStruct->itemID,MF_BYCOMMAND) ; 

		if ( nFlags & MF_SEPARATOR ) 
		{
			
			CBrush brush(RGB(255,255,255)) ; 
			CRect rectItem(&rc) ; 
			rectItem.DeflateRect(0,1) ; 
			
			CBrush brInterior(clrBkg) ; 
			//pDC->FillRect(&rc,&brInterior) ; 
			//pDC->FrameRect(&rectItem,&brush) ;

		}
		else 
		{
			
			pDC->FillSolidRect(&rc,clrBkg);
		}
	
	       
	}
	if (!(lpDrawItemStruct->itemState & ODS_SELECTED) && (lpDrawItemStruct->itemAction & ODA_SELECT))
	{
	  //item has been deselected 
	  CBrush br(clrBkg);
      pDC->FrameRect(&rc, &br);
	  pDC->FillRect(&rc,&br); 
	  
	}
	
	DrawItem(pDC,lpDrawItemStruct,menuData) ; 


}

void CSkinMenu::MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct)
{
	UINT nFlags = GetMenuState(lpMeasureItemStruct->itemID,MF_BYCOMMAND) ;  
	CSize size = MeasureItemSize(lpMeasureItemStruct->itemID) ; 

	if ( nFlags & MF_SEPARATOR ) 
	{
		lpMeasureItemStruct->itemHeight = 5 ;
		lpMeasureItemStruct->itemWidth = 165 ; 
	}
	else 
	{
		CSize sz ; 
		if (IsBitmapMenuItems(sz))
		{
			lpMeasureItemStruct->itemHeight = sz.cy; 
			lpMeasureItemStruct->itemWidth = size.cx ;
		}
		else 
		{
			lpMeasureItemStruct->itemHeight = size.cy ; 
			lpMeasureItemStruct->itemWidth = size.cx ; 
		}
		 	
	}
}
void CSkinMenu::DrawItem (CDC* pDC,LPDRAWITEMSTRUCT lpDrawItemStruct,MenuData* menuData)   
{
	//UINT nFlags = GetMenuState(lpDrawItemStruct->itemID,MF_BYCOMMAND) ;  
	MENUITEMINFO mi ; ZeroMemory(&mi,sizeof(MENUITEMINFO)) ; 
	mi.cbSize = sizeof(MENUITEMINFO) ;
	mi.fMask = MIIM_FTYPE | MIIM_SUBMENU ;
	UINT nID = lpDrawItemStruct->itemID ; 
	GetMenuItemInfo(lpDrawItemStruct->itemID,&mi) ; 
	
	UINT nFlags = mi.fType ; 

	CRect rc = lpDrawItemStruct->rcItem ; 
	CString strText = menuData->strText; 
	COLORREF clrText = menuData->clrText ; 
	COLORREF clrBkg = menuData->clrBkg ; 
	COLORREF clrHilite = menuData->clrHiLite ; 

	
	HBITMAP hBitmap = menuData->bmpItem ;  
	HBITMAP hBmpUnchecked = menuData->bmpUchecked ; 
	CFont* pFont = menuData->fontText ; 
	CFont* pOldFont = NULL ; 
	
	if ( nFlags & MFT_SEPARATOR ) 
	{
		if (hBitmap)
		{
			CDC memDC ; 
			memDC.CreateCompatibleDC(pDC) ; 
			HBITMAP hBmpOld= (HBITMAP)memDC.SelectObject(hBitmap) ; 
			BITMAP bmpInfo ; 
			::GetObject(hBitmap,sizeof(BITMAP),&bmpInfo) ; 
			pDC->BitBlt(rc.left,rc.top ,bmpInfo.bmWidth,bmpInfo.bmHeight,&memDC,0,0,SRCCOPY) ; 	
			memDC.SelectObject(hBmpOld) ; 
			memDC.DeleteDC() ; 
		}
		else 
		{
			CRect rectSep(rc) ; 
			rectSep.DeflateRect(0,2); 
			pDC->FillSolidRect(&rc,clrBkg) ; 
			pDC->FillSolidRect(&rectSep,clrHilite) ; 
		}
	
		
	}
	else if (nFlags & MFT_OWNERDRAW && mi.hSubMenu == NULL  )
	{
		UINT miState = GetMenuState(nID,MF_BYCOMMAND) ; 
		
		if ((miState & MF_CHECKED) || (miState & MF_UNCHECKED))
		{
			CDC memDC ; 
			memDC.CreateCompatibleDC(pDC) ;
			HBITMAP hBmpOld = NULL  ; 
			BITMAP bmpInfo ; 
			
			if (hBmpUnchecked != NULL && miState & MF_UNCHECKED ) 
			{
				hBmpOld= (HBITMAP)memDC.SelectObject(hBmpUnchecked) ; 
				::GetObject(hBitmap,sizeof(BITMAP),&bmpInfo) ; 
				pDC->BitBlt(rc.left + 1,rc.top + 1,bmpInfo.bmWidth,bmpInfo.bmHeight,&memDC,0,0,SRCCOPY) ; 
				memDC.SelectObject(hBmpOld) ;
				memDC.DeleteDC() ; 
				rc.left += bmpInfo.bmWidth + 5 ; 
			}
			else if (hBitmap != NULL &&  (miState & MF_CHECKED) ) 
			{
				hBmpOld= (HBITMAP)memDC.SelectObject(hBitmap) ; 
				::GetObject(hBitmap,sizeof(BITMAP),&bmpInfo) ;
				pDC->BitBlt(rc.left + 1,rc.top + 1,bmpInfo.bmWidth,bmpInfo.bmHeight,&memDC,0,0,SRCCOPY) ; 
				memDC.SelectObject(hBmpOld) ;
				memDC.DeleteDC() ; 
				rc.left += bmpInfo.bmWidth + 5 ; 
				 

			}
			else 
			{
				CSize sz ;
				if (IsBitmapMenuItems(sz) )
				{
					rc.left += sz.cx + 5  ; 
				}
				else 
					rc.left += 2 ; 

			}

		}
		else 
		{
			if (hBitmap)
			{
				CDC memDC ; 
				memDC.CreateCompatibleDC(pDC) ; 
				HBITMAP hBmpOld= (HBITMAP)memDC.SelectObject(hBitmap) ; 
				BITMAP bmpInfo ; 
				::GetObject(hBitmap,sizeof(BITMAP),&bmpInfo) ; 
				pDC->BitBlt(rc.left + 1,rc.top + 1,bmpInfo.bmWidth,bmpInfo.bmHeight,&memDC,0,0,SRCCOPY) ; 
				memDC.SelectObject(hBmpOld) ;
				memDC.DeleteDC() ; 
				rc.left += bmpInfo.bmWidth + 5 ; 
			}
			else 
			{
				CSize sz ;
				if (IsBitmapMenuItems(sz) )
				{
					rc.left += sz.cx + 5  ; 
				}
				else 
					rc.left += 2 ;   
			}

		}

		if (pFont) 
			pOldFont = pDC->SelectObject(pFont) ; 

		UINT nState = GetMenuState(lpDrawItemStruct->itemID,MF_BYCOMMAND) ; 

		pDC->SetTextColor(clrText) ;  
		
		if (nState & (MF_DISABLED | MF_GRAYED) ) 
		{
			pDC->SetTextColor(menuData->clrTxtDisable) ; 
		}
				
		pDC->SetBkMode(TRANSPARENT) ; 
		pDC->DrawText(strText,&rc,DT_LEFT | DT_SINGLELINE | DT_VCENTER) ; 
       			

		
	}
	else 
	{
		CDC memDC ; 
		memDC.CreateCompatibleDC(pDC) ;
		HBITMAP hBmpOld = NULL  ; 
		BITMAP bmpInfo ; 
		
		if (hBitmap)
		{
			CDC memDC ; 
			memDC.CreateCompatibleDC(pDC) ; 
			HBITMAP hBmpOld= (HBITMAP)memDC.SelectObject(hBitmap) ; 
			BITMAP bmpInfo ; 
			::GetObject(hBitmap,sizeof(BITMAP),&bmpInfo) ; 
			pDC->BitBlt(rc.left + 1,rc.top + 1,bmpInfo.bmWidth,bmpInfo.bmHeight,&memDC,0,0,SRCCOPY) ; 
			memDC.SelectObject(hBmpOld) ;
			memDC.DeleteDC() ; 
			rc.left += bmpInfo.bmWidth + 5 ; 
		}
		else 
		{
			CSize sz ;
			if (IsBitmapMenuItems(sz) )
			{
				CRect rectItem (rc) ;
				rc.left += sz.cx + 5  ; 
			}
			else 
				rc.left += 2 ; 
		}
		
		if (pFont) 
			pOldFont = pDC->SelectObject(pFont) ; 
		
		pDC->SetTextColor(clrText) ;
		pDC->SetBkMode(TRANSPARENT) ; 
		pDC->DrawText(strText,&rc,DT_LEFT | DT_SINGLELINE | DT_VCENTER) ; 


	}


}


void CSkinMenu::AppendMenuItem(int nID,HBITMAP bmpItem,CFont* fontText,CString strText,COLORINDEX* paColors,UINT nCount) 
{
	 
	  MenuData* menuData = new MenuData() ; 
	   menuData->nID = nID ; 
	  menuData->strText = strText ; 
	  menuData->bmpItem = bmpItem ; 
	  menuData->bmpUchecked = NULL ;
	  menuData->fontText = fontText ; 

	  SetMenuItemColors(menuData,paColors,nCount) ; 
	  m_aoItems.AddTail(menuData) ; 

	  CMenu::AppendMenu(MF_OWNERDRAW | MF_BYCOMMAND ,nID,strText) ; 
	

}
void CSkinMenu::AppendCheckedMenuItem (int nID,HBITMAP bmpItem,HBITMAP bmpUnchecked,CFont* fontText,CString strName,COLORINDEX* paColors,UINT nCount)
								  
{
	
	  CMenu::AppendMenu(MF_CHECKED | MF_OWNERDRAW ,nID,strName) ;   
	  MenuData* minfo = new MenuData() ; 
	 
	  minfo->nID = nID ; 
	  minfo->strText = strName ; 
	  minfo->bmpItem = bmpItem ; 
	  minfo->bmpUchecked = bmpUnchecked ; 
	  minfo->fontText = fontText ; 
	  SetMenuItemColors(minfo,paColors,nCount) ; 
	  m_aoItems.AddTail(minfo) ; 

}

void CSkinMenu::AppendMenuItem2(int nID,UINT uBmpResItemID,CFont* fontText,CString strText,COLORINDEX* paColors,UINT nCount) 
	{
	  
	 
	  CMenu::AppendMenu(MF_OWNERDRAW | MF_BYCOMMAND  ,nID,strText) ;  
	  MenuData* minfo = new MenuData() ; 
	  minfo->nID = nID ;  
	  minfo->strText = strText ; 
	  minfo->bmpItem = LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(uBmpResItemID)) ; 
	  minfo->bmpUchecked = NULL ;
	  minfo->fontText = fontText ; 
		
	  SetMenuItemColors(minfo,paColors,nCount) ;  
	  m_aoItems.AddTail(minfo) ;
	}

void CSkinMenu::AppendCheckedMenuItem (int nID,UINT uBmpResItemID,UINT uBmpResUncheckedItemID,CFont* fontText,CString strName,COLORINDEX* paColors,UINT nCount)
{
	  
	    
	  MenuData* minfo = new MenuData() ; 
	  minfo->nID = nID ;  
	  minfo->strText = strName ; 
	  minfo->bmpItem = LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(uBmpResItemID)) ; 
	  minfo->bmpUchecked =  LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(uBmpResUncheckedItemID)) ; 
	  minfo->fontText = fontText ; 
	  SetMenuItemColors(minfo,paColors,nCount) ; 
      m_aoItems.AddTail(minfo) ; 

	  CMenu::AppendMenu(MF_CHECKED | MF_OWNERDRAW | MF_BYCOMMAND ,nID,strName) ;


}
void CSkinMenu::AppendPopUpMenu (int nID,CSkinMenu* menuPopUp,HBITMAP bmpItem,CFont* fontText,CString strName,COLORINDEX* paColors,UINT nCount) 
{
			
		CMenu::AppendMenu(MF_POPUP |  MF_OWNERDRAW | MF_BYCOMMAND,nID,strName) ; 
			
		MENUITEMINFO mi ; 
		mi.cbSize = sizeof(MENUITEMINFO) ; 
		mi.fMask = MIIM_SUBMENU ;
		mi.hSubMenu = menuPopUp->m_hMenu ; 
		SetMenuItemInfo(nID,&mi);

	
		MenuData* minfo = new MenuData() ; 
		minfo->nID = nID ;  
		minfo->strText = strName ; 
		minfo->bmpItem =  bmpItem ; 
		minfo->bmpUchecked = NULL ;
		minfo->fontText = fontText ; 

		SetMenuItemColors(minfo,paColors,nCount) ; 
		m_aoItems.AddTail(minfo) ; 
}


void CSkinMenu::AppendSeparator(int nID,UINT uBmpResItemID,COLORREF clrBkg,COLORREF clrInterior)
{
	  CMenu::AppendMenu(MF_SEPARATOR | MF_OWNERDRAW ,nID,_T("")) ;   
	  MenuData* minfo = new MenuData() ; 
	  minfo->nID = nID ; 
	  if (uBmpResItemID != 0) 
		minfo->bmpItem = LoadBitmap(AfxGetInstanceHandle(),MAKEINTRESOURCE(uBmpResItemID)) ; 
	  else 
		  minfo->bmpItem = NULL ; 

	  minfo->clrBkg = clrBkg ; 
	  minfo->clrHiLite = clrInterior ; 
	  m_aoItems.AddTail(minfo) ; 
	 
}
MenuData* CSkinMenu::GetItemData(UINT nID) 
{
	MenuData* menuData = NULL  ;  
	POSITION ps = m_aoItems.GetHeadPosition() ; 
	 while(ps) 
	 {
		  menuData = (MenuData*)m_aoItems.GetAt(ps) ;  
		 if (menuData->nID == nID) break ; 
		 m_aoItems.GetNext(ps) ; 
	 }
	return menuData ; 

}

void CSkinMenu::SetMenuItemColors (MenuData* menuData,COLORINDEX* paColors,UINT nCount) 
{
	for (int i =0 ; i < nCount;i++) 
	{
		COLORINDEX index = paColors[i] ; 
		switch (index.nID) 
		{
			case CLR_TEXT :  menuData->clrText = index.clr ; break ; 
			case CLR_INTERIOR : menuData->clrBkg = index.clr ; break ; 
			case CLR_HILITE: menuData->clrHiLite = index.clr ; break ;
			case CLR_FRAME: menuData->cltBorder = index.clr ; break ;  
			case CLR_TEXT_DISABLED: menuData->clrTxtDisable = index.clr ;break ; 
			case CLR_DISABLED: menuData->clrItemDisable = index.clr ; break ;

		}
	}

}
CSize CSkinMenu::MeasureItemSize (UINT nID)  
{
	int nWidth = 0  ,nHeight = 0 ;  
	MenuData* menuData = GetItemData(nID) ; 
	 
	CString strText = menuData->strText ; 
	TRACE("\"");
	TRACE(strText.GetBuffer());
	TRACE("\"\n");
	CBitmap pBmp ; pBmp.Attach(menuData->bmpItem) ; 
	CFont* pFont = menuData->fontText ; 

	CDC* pDC = CDC::FromHandle(GetDC(GetDesktopWindow())) ; 
	CDC memDC ; 
	CFont* oldFont ; 
	memDC.CreateCompatibleDC(pDC) ; 

	if (pFont != NULL) 
	{
		oldFont = memDC.SelectObject(pFont) ;  
		CSize szText = memDC.GetTextExtent(strText) ;  
		
		nWidth = szText.cx + 10 ; 
		nHeight =  szText.cy  ; 

		BITMAP bmpInfo ;
		if (pBmp.m_hObject != NULL) 
		{		
			pBmp.GetBitmap(&bmpInfo) ; 
			nWidth = bmpInfo.bmWidth + szText.cx + 5 ; 
			if (bmpInfo.bmHeight > nHeight) 
				nHeight = bmpInfo.bmHeight ; 
			
		}	
	}

	else if (pBmp.m_hObject != NULL) 
	{
		BITMAP bmpInfo ; 
		pBmp.GetBitmap(&bmpInfo) ; 
		CSize szText = pDC->GetTextExtent(strText) ; 
		nWidth = bmpInfo.bmWidth + szText.cx + 5 ; 
		if (bmpInfo.bmHeight > nHeight) 
				nHeight = bmpInfo.bmHeight ; 

	}
	else 
	{
		CSize szText = pDC->GetTextExtent(strText) ; 
		nWidth = szText.cx + 10 ; 
		nHeight =  szText.cy  ; 

	}

	if (pFont != NULL)
		memDC.SelectObject(oldFont) ;
	
	

	if (pBmp.m_hObject != NULL) 
		pBmp.Detach() ; 


	memDC.DeleteDC() ; 
	ReleaseDC(GetDesktopWindow(),pDC->m_hDC) ;   

	return CSize(nWidth,nHeight) ;
    
	

}
BOOL CSkinMenu::IsBitmapMenuItems (CSize& sz) 
{
	BOOL bRet = FALSE ; 

	POSITION ps = m_aoItems.GetHeadPosition() ; 
	while (ps) 
	{
		MenuData* menuData = m_aoItems.GetAt(ps) ; 
		MENUITEMINFO mi ;
		mi.cbSize = sizeof(MENUITEMINFO) ; 
		mi.fMask = MIIM_SUBMENU ; 
		GetMenuItemInfo(menuData->nID,&mi) ; 
				 
		if (menuData->bmpItem != NULL )
		{
			BITMAP bmpInfo ; 
			::GetObject(menuData->bmpItem,sizeof(BITMAP),&bmpInfo) ; 
			sz.cx = bmpInfo.bmWidth ; 
			sz.cy = bmpInfo.bmHeight ; 
			bRet = TRUE ; 
			
		}
		m_aoItems.GetNext(ps) ; 

	}
	return bRet ; 


}
